//bridge-file-version: #0
import { world, system, Player, BlockPermutation, ItemStack, Block } from "@minecraft/server";

class loreItem {
    constructor(itemId, lore) {
        this.itemId = itemId;
        this.lore = lore;
    }
}

// Lore Descriptions > On Hit Buff =  | On Hit Penalty =  | Carving = | Interact Effect =  | Cooldown =  | On Miss = 

const ItemArray = [
    new loreItem("saveint:wooden_sledge_hammer", ['','§6│§c-Slowness CCLV (0:05)§6│','§6│§c    -Weakness CCLV (0:03)§6│','','§6│§5-3x3 Veinminer§6│']),
    new loreItem("satvein:stone_sledge_hammer", ['','§6│§c-Slowness CCLV (0:05)§6│','§6│§c    -Weakness CCLV (0:03)§6│','','§6│§5-3x3 Veinminer§6│']),
    new loreItem("satvein:iron_sledge_hammer", ['','§6│§c-Slowness CCLV (0:05)§6│','§6│§c    -Weakness CCLV (0:03)§6│','','§6│§5-3x3 Veinminer§6│']),
    new loreItem("satvein:gold_sledge_hammer", ['','§6│§c-Slowness CCLV (0:05)§6│','§6│§c    -Weakness CCLV (0:03)§6│','','§6│§5-3x3 Veinminer§6│']),
    new loreItem("satvein:diamond_sledge_hammer", ['','§6│§c-Slowness CCLV (0:05)§6│','§6│§c    -Weakness CCLV (0:03)§6│','','§6│§5-3x3 Veinminer§6│']),
    new loreItem("satvein:netherite_sledge_hammer", ['','§6│§c-Slowness CCLV (0:05)§6│','§6│§c    -Weakness CCLV (0:03)§6│','','§6│§5-3x3 Veinminer§6│']),
];

system.runInterval(() => { // Lore Controls
    for (const player of world.getPlayers()) { // Gets all players
        const playerContainer = player.getComponent("inventory").container; //
        for (let i = 0; i < playerContainer.size; i++) {
            const item = playerContainer.getItem(i);
            const findLore = ItemArray.find(x => x.itemId == item?.typeId);
            const lore = item?.getLore();
            if (!findLore || !item?.amount || lore?.length != 0) continue;
            item.setLore(findLore.lore);
            playerContainer.setItem(i, item);
        }
    }
}, 1);

const sledgeHammerCustomComponent = {
  sledgeHammerFunctionality: {
    onHitEntity(e) {
      const { hitEntity, attackingEntity } = e;
      
      attackingEntity.addEffect('slowness', 100, { amplifier: 255 });
      attackingEntity.addEffect('weakness', 60, { amplifier: 255 });
      
      const item = e.item;
      if (item) {
        const equipment = attackingEntity.getComponent('equippable');
        const mainHand = equipment.getEquipment("Mainhand");
        const durability = mainHand.getComponent('durability');
        const durabilityAffliction = 1; 
  
        if (durability.damage + durabilityAffliction >= durability.maxDurability) {
          attackingEntity.runCommandAsync("replaceitem entity @s slot.weapon.mainhand 0 air");
          attackingEntity.runCommandAsync("playsound random.break @a[r=16] ~ ~ ~");
        } else {
          durability.damage += durabilityAffliction;
        }
      }
    },
    onUseOn: (e) => {
          const player = e.source;
          const block = e.block;
          const blockLocation = block.location;
          const equipment = player.getComponent('equippable');
          const mainHand = equipment.getEquipment("Mainhand");
          const durability = mainHand.getComponent('durability');
          const durabilityAffliction = 1;

          player.runCommandAsync(`playsound mob.zombie.woodbreak @a[r=16] ${blockLocation.x} ${blockLocation.y} ${blockLocation.z} 1 0.8`);
          player.runCommandAsync(`fill ${blockLocation.x - 1} ${blockLocation.y - 1} ${blockLocation.z - 1} ${blockLocation.x + 1} ${blockLocation.y + 1} ${blockLocation.z + 1} air destroy`);
          player.runCommandAsync(`kill @e[type=item,name=bedrock`);
          player.runCommandAsync(`fill ~-5 -64 ~-5 ~5 -64 ~5 bedrock`);
          
          if (durability.damage + 5 >= durability.maxDurability) {
              const gamemode = player.getGameMode();
              if (gamemode === 'survival' || gamemode === 'adventure') {
                  player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
                  player.runCommandAsync(`playsound random.break @a[r=16] ~ ~ ~`);
              }
          } else {
              if (durability.damage < durability.maxDurability) {
                  const gamemode = player.getGameMode();
                  if (gamemode === 'survival' || gamemode === 'adventure') {
                      durability.damage += 5;
                      equipment.setEquipment("Mainhand", mainHand);
                  }
              }
          }
      }
  }
};

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
  initEvent.itemComponentRegistry.registerCustomComponent("sat:sledge_hammer_functionality", sledgeHammerCustomComponent.sledgeHammerFunctionality);
});

